<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::Stopwatch Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1Stopwatch.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1Stopwatch-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::Stopwatch Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Record and report elapsed real time ("clock" or "wall" time) in seconds.  
 <a href="classOpenSim_1_1Stopwatch.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aebde4d957ec3a97a275a243585f6db85"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Stopwatch.html#aebde4d957ec3a97a275a243585f6db85">Stopwatch</a> ()</td></tr>
<tr class="memdesc:aebde4d957ec3a97a275a243585f6db85"><td class="mdescLeft">&#160;</td><td class="mdescRight">This stores the start time as the current time.  <a href="classOpenSim_1_1Stopwatch.html#aebde4d957ec3a97a275a243585f6db85">More...</a><br /></td></tr>
<tr class="separator:aebde4d957ec3a97a275a243585f6db85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a975fa8dc91ee53bfaab50be296b05139"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Stopwatch.html#a975fa8dc91ee53bfaab50be296b05139">reset</a> ()</td></tr>
<tr class="memdesc:a975fa8dc91ee53bfaab50be296b05139"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset the start time to the current time.  <a href="classOpenSim_1_1Stopwatch.html#a975fa8dc91ee53bfaab50be296b05139">More...</a><br /></td></tr>
<tr class="separator:a975fa8dc91ee53bfaab50be296b05139"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a175f2b6e237b0851ae1c766cc9d0f930"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Stopwatch.html#a175f2b6e237b0851ae1c766cc9d0f930">getElapsedTime</a> () const</td></tr>
<tr class="memdesc:a175f2b6e237b0851ae1c766cc9d0f930"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the amount of time that has elapsed since this object was constructed or since <a class="el" href="classOpenSim_1_1Stopwatch.html#a975fa8dc91ee53bfaab50be296b05139" title="Reset the start time to the current time.">reset()</a> has been called.  <a href="classOpenSim_1_1Stopwatch.html#a175f2b6e237b0851ae1c766cc9d0f930">More...</a><br /></td></tr>
<tr class="separator:a175f2b6e237b0851ae1c766cc9d0f930"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a15537e5996fdfc438764ecb9e2df7e30"><td class="memItemLeft" align="right" valign="top">long long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Stopwatch.html#a15537e5996fdfc438764ecb9e2df7e30">getElapsedTimeInNs</a> () const</td></tr>
<tr class="memdesc:a15537e5996fdfc438764ecb9e2df7e30"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get elapsed time in nanoseconds.  <a href="classOpenSim_1_1Stopwatch.html#a15537e5996fdfc438764ecb9e2df7e30">More...</a><br /></td></tr>
<tr class="separator:a15537e5996fdfc438764ecb9e2df7e30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0da5fe14b67b76a54b9156bc2d45f3c3"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Stopwatch.html#a0da5fe14b67b76a54b9156bc2d45f3c3">getElapsedTimeFormatted</a> () const</td></tr>
<tr class="memdesc:a0da5fe14b67b76a54b9156bc2d45f3c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">This provides the elapsed time as a formatted string (using format()).  <a href="classOpenSim_1_1Stopwatch.html#a0da5fe14b67b76a54b9156bc2d45f3c3">More...</a><br /></td></tr>
<tr class="separator:a0da5fe14b67b76a54b9156bc2d45f3c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ae93219fae4e331bddf5b32fc690195a2"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Stopwatch.html#ae93219fae4e331bddf5b32fc690195a2">formatNs</a> (const long long &amp;nanoseconds)</td></tr>
<tr class="memdesc:ae93219fae4e331bddf5b32fc690195a2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Format the provided elapsed time in nanoseconds into a string.  <a href="classOpenSim_1_1Stopwatch.html#ae93219fae4e331bddf5b32fc690195a2">More...</a><br /></td></tr>
<tr class="separator:ae93219fae4e331bddf5b32fc690195a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>Record and report elapsed real time ("clock" or "wall" time) in seconds. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aebde4d957ec3a97a275a243585f6db85"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aebde4d957ec3a97a275a243585f6db85">&#9670;&nbsp;</a></span>Stopwatch()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Stopwatch::Stopwatch </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This stores the start time as the current time. </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1Stopwatch.html#a975fa8dc91ee53bfaab50be296b05139">reset()</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae93219fae4e331bddf5b32fc690195a2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae93219fae4e331bddf5b32fc690195a2">&#9670;&nbsp;</a></span>formatNs()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::string OpenSim::Stopwatch::formatNs </td>
          <td>(</td>
          <td class="paramtype">const long long &amp;&#160;</td>
          <td class="paramname"><em>nanoseconds</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Format the provided elapsed time in nanoseconds into a string. </p>
<p>The time may be converted into seconds, milliseconds, or microseconds. Additionally, if the time is greater or equal to 60 seconds, the time in hours and/or minutes is also added to the string. Usually, you can call <a class="el" href="classOpenSim_1_1Stopwatch.html#a0da5fe14b67b76a54b9156bc2d45f3c3" title="This provides the elapsed time as a formatted string (using format()).">getElapsedTimeFormatted()</a> instead of calling this function directly. If you call this function directly, use <a class="el" href="classOpenSim_1_1Stopwatch.html#a15537e5996fdfc438764ecb9e2df7e30" title="Get elapsed time in nanoseconds.">getElapsedTimeInNs()</a> to get a time in nanoseconds (rather than <a class="el" href="classOpenSim_1_1Stopwatch.html#a175f2b6e237b0851ae1c766cc9d0f930" title="Return the amount of time that has elapsed since this object was constructed or since reset() has bee...">getElapsedTime()</a>). </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Stopwatch.html#a0da5fe14b67b76a54b9156bc2d45f3c3">getElapsedTimeFormatted()</a>.</p>

</div>
</div>
<a id="a175f2b6e237b0851ae1c766cc9d0f930"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a175f2b6e237b0851ae1c766cc9d0f930">&#9670;&nbsp;</a></span>getElapsedTime()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double OpenSim::Stopwatch::getElapsedTime </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the amount of time that has elapsed since this object was constructed or since <a class="el" href="classOpenSim_1_1Stopwatch.html#a975fa8dc91ee53bfaab50be296b05139" title="Reset the start time to the current time.">reset()</a> has been called. </p>

</div>
</div>
<a id="a0da5fe14b67b76a54b9156bc2d45f3c3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0da5fe14b67b76a54b9156bc2d45f3c3">&#9670;&nbsp;</a></span>getElapsedTimeFormatted()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string OpenSim::Stopwatch::getElapsedTimeFormatted </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This provides the elapsed time as a formatted string (using format()). </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1Stopwatch.html#ae93219fae4e331bddf5b32fc690195a2">formatNs()</a>, and <a class="el" href="classOpenSim_1_1Stopwatch.html#a15537e5996fdfc438764ecb9e2df7e30">getElapsedTimeInNs()</a>.</p>

</div>
</div>
<a id="a15537e5996fdfc438764ecb9e2df7e30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a15537e5996fdfc438764ecb9e2df7e30">&#9670;&nbsp;</a></span>getElapsedTimeInNs()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">long long OpenSim::Stopwatch::getElapsedTimeInNs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get elapsed time in nanoseconds. </p>
<p>See SimTK::realTimeInNs() for more information. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Stopwatch.html#a0da5fe14b67b76a54b9156bc2d45f3c3">getElapsedTimeFormatted()</a>.</p>

</div>
</div>
<a id="a975fa8dc91ee53bfaab50be296b05139"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a975fa8dc91ee53bfaab50be296b05139">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::Stopwatch::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reset the start time to the current time. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Stopwatch.html#aebde4d957ec3a97a275a243585f6db85">Stopwatch()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/Stopwatch.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1Stopwatch.html">Stopwatch</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:50 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
